/*
- many thanks to God [YHWH, Yahwéh, Jehovah's, Geova]: He made life possible, and all you can do with it;
- many thanks to my wife and my children for their patience;
- many thanks to Rory Walsh for Cabbage and his great support (http://forum.cabbageaudio.com/);
- many thanks to Iain McCurdy, for his great support and all code shared (http://iainmccurdy.org/);
- many thanks to all users presents in the Cabbage forum: Kevin Welsh (tgrey) and Guillermo Senna (gsenna) in particular for your support and all code shared (http://forum.cabbageaudio.com/)
- many thanks to Riccardo Bianchini, Alessandro Cipriani, Giorgio Zucco, Jim Aikin for their wonderful books and "Vallste" for his (old) support (http://triceratupuz.altervista.org/);
- many thanks to Barry Vercoe, Richard Boulanger, Max Mathews and all Csound developers in the world (http://www.csounds.com/);

I'm not a writer of professional code in csound...

Author: Tonetta Ivan (Ruben) - 2016.04 - Italy - Cabbage 1.04


####################################################################################################################################
#                                                                                                                                  #
#   The Leslie Speaker Code is taken from the example made by Iain McCurdy (all the code founded in inst 1000, inst 901 and UDO)   #
#                                                                                                                                  #
####################################################################################################################################

*/

<Cabbage>
; the principal GUI colors are sets here:
#define GUI_COLOR    trackercolour(128,030,000,255), fontcolour:0(255,255,255,155), fontcolour:1(255,255,255,255)
#define GROUPBOX_COLOR colour(128,030,000,020)

form caption("CabOrgan1.1") size(750, 500), colour("black"), pluginID("CbO11"), svgpath("Skin")
keyboard bounds(000,455,603,045), value(36)

groupbox bounds(004,004,310,150), text(""), linethickness(0), plant("Image"){ 
	image    bounds(000,000,310,150), file("Skin/Background.png")
}
groupbox bounds(324,170,330,240), text(""), $GROUPBOX_COLOR, plant("Partials"){ 
	label    bounds(140,002,180,015), text("Partials"), align("left"), $GUI_COLOR
	vslider  bounds(-50,-70,050,200), channel("a1"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(-15,-70,050,200), channel("a2"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(020,-70,050,200), channel("a3"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(055,-70,050,200), channel("a4"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(090,-70,050,200), channel("a5"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(125,-70,050,200), channel("a6"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(160,-70,050,200), channel("a7"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(195,-70,050,200), channel("a8"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
	vslider  bounds(230,-70,050,200), channel("a9"),  range(0, 1, 1), $GUI_COLOR, trackerthickness(.25),   gradient(1),        rotate(3.14,050,150)
}
groupbox bounds(660,004,085,405), $GROUPBOX_COLOR, plant("Other"){ 
	rslider  bounds(013,050,060,060), channel("cliclvl"), range( 0,     1,    0,    0.5, .001), $GUI_COLOR
	rslider  bounds(013,130,060,060), channel("perclvl"), range( 0,     1.5,  1,    0.5, .001), $GUI_COLOR
	rslider  bounds(013,220,060,060), channel("perctne"), range( 0,     3,    0,    1,   1   ), $GUI_COLOR
	rslider  bounds(013,340,060,060), channel("percdec"), range(.00001, 3,    1,    1,   .01 ), identchannel("knobdec"), $GUI_COLOR
	button   bounds(002,290,086,020), channel("percenv"), text("Decay, Note"), colour:0(128,030,000,020), colour:1(128,030,000,255)
	label    bounds(010,030,100,015), text("Clic Level"), align("left"), $GUI_COLOR
	label    bounds(007,115,100,015), text("Perc Level"), align("left"), $GUI_COLOR
	label    bounds(007,200,100,015), text("Perc Tune"),  align("left"), $GUI_COLOR
	label    bounds(005,320,100,015), text("Perc Decay"), align("left"), identchannel("labdec"), $GUI_COLOR
	label    bounds(020,002,038,015), text("Perc"),  align("center"), $GUI_COLOR
}
groupbox bounds(004,170,310,240), text(""), $GROUPBOX_COLOR, plant("Global")
{ 
	label    bounds(105,002,180,015), text("Leslie & Global"), align("left"), $GUI_COLOR
	button   bounds(020,025,060,025), colour:0(128,030,000,020), colour:1(128,030,000,255), $GUI_COLOR, text("Off, On"),       channel("lesonoff")
	button   bounds(080,025,060,025), colour:0(128,030,000,020), colour:1(128,030,000,255), $GUI_COLOR, text("OffSet, OnSet"), channel("setup_Button")
	button   bounds(160,025,060,025), colour:0(128,030,000,020), colour:1(128,030,000,255), $GUI_COLOR, text("Slow","Slow"),   channel("Slow"), latched(1), radiogroup(1), value(1)
	button   bounds(220,025,060,025), colour:0(128,030,000,020), colour:1(128,030,000,255), $GUI_COLOR, text("Fast","Fast"),   channel("Fast"), latched(1), radiogroup(1)
	rslider  bounds(010,170,060,060), channel("tube"),    range(.00001, .2,  .001, .5,  .001), identchannel("tubknob"), $GUI_COLOR
	rslider  bounds(240,170,060,060), channel("master"),  range( 0,     1,   .2,   .5,  .001), identchannel("masknob"), $GUI_COLOR
	label    bounds(023,150,100,015), text("Tube"),    align("left"), identchannel("tublab"), $GUI_COLOR
	label    bounds(247,150,100,015), text("Master"),  align("left"), identchannel("maslab"), $GUI_COLOR
}

groupbox     bounds(004,225,310,185), plant("Setup"), $GROUPBOX_COLOR, linethickness(0), identchannel("setupPlant"){
	image     bounds(002,000,147,185), outlinethickness(1), colour(000,000,000,000)
	label     bounds(000,004,155,014), text("Woofer"), fontcolour(255,255,255,155)
	numberbox bounds(010,020,060,040), channel("CF_Low"), text("Cutoff"),     range(20,8000,800,1,1)
	numberbox bounds(080,020,060,040), channel("LF_Damp"), text("Damping"),   range(0.01,8,1.5,1,0.01)
	numberbox bounds(010,060,060,040), channel("LF_Slow"), text("RPM Slow"),  range(5,1000, 40,1,1)
	numberbox bounds(080,060,060,040), channel("LF_Fast"), text("RPM Fast"),  range(5,1000,342,1,1)
	numberbox bounds(010,100,060,040), channel("LF_Dop"), text("Doppler"),    range(0,2,0.1)
	numberbox bounds(080,100,060,040), channel("LF_Pan"), text("Panning"),    range(0,1,0.2,1,0.01)
	numberbox bounds(010,140,060,040), channel("LF_Amp"), text("Amplitude"),  range(0,1,0.3,1,0.01)
	
	image     bounds(161,000,147,185), outlinethickness(1), colour(000,000,000,000)
	label     bounds(161,004,155,014), text("Tweeter"), fontcolour(255,255,255,155)
	numberbox bounds(170,020,060,040), channel("CF_High"), text("Cutoff"),    range(20,8000,800,1,1)
	numberbox bounds(240,020,060,040), channel("HF_Damp"), text("Damping"),   range(0.01,8,0.5,1,0.01)
	numberbox bounds(170,060,060,040), channel("HF_Slow"), text("RPM Slow"),  range(5,1000, 48,1,1)
	numberbox bounds(240,060,060,040), channel("HF_Fast"), text("RPM Fast"),  range(5,1000,400,1,1)
	numberbox bounds(170,100,060,040), channel("HF_Dop"), text("Doppler"),    range(0,2,0.2)
	numberbox bounds(240,100,060,040), channel("HF_Pan"), text("Panning"),    range(0,1,0.4,1,0.01)
	numberbox bounds(170,140,060,040), channel("HF_Amp"), text("Amplitude"),  range(0,1,0.3,1,0.01)
}

groupbox bounds(324,004,330,150), text(""), $GROUPBOX_COLOR, plant("Reverb"){ 
	rslider  bounds(010,060,060,060), channel("reverb"), $GUI_COLOR, range(0, 1, .1)
	rslider  bounds(133,060,060,060), channel("room"),   $GUI_COLOR, range(0, 1, .1)
	rslider  bounds(260,060,060,060), channel("dmph"),   $GUI_COLOR, range(0, 1, .1)
	label    bounds(140,002,100,015), text("Reverb"), align("left"), $GUI_COLOR
	label    bounds(015,040,100,015), text("Reverb"), align("left"), $GUI_COLOR
	label    bounds(143,040,100,015), text("Room"),   align("left"), $GUI_COLOR
	label    bounds(265,040,100,015), text("Damph"),  align("left"), $GUI_COLOR
}
groupbox   bounds(004,420,600,027), linethickness(0), $GROUPBOX_COLOR, plant("Background"){ 
	combobox   bounds(290,004,260,020), channel("combobox"), populate("*.snaps", "Presets"), align("left")
	filebutton bounds(555,004,040,020), channel("save"), text("Save"), populate("*.snaps", "Presets")
	label      bounds(004,006,180,015), text("Tonetta Ivan - 2016.04"), align("left"), $GUI_COLOR
	infobutton bounds(180,004,100,020), channel("info"),  file("About/About.html"), text("Info")
}
</Cabbage>  
<CsoundSynthesizer>
<CsOptions>
-dm0 -n -+rtmidi=NULL -M0 ;--midi-velocity-amp=5 ;--midi-key-cps=4
</CsOptions>
<CsInstruments>
sr 		    = 	44100
ksmps 		= 	16
nchnls 		= 	2
0dbfs		=	1

gisine ftgen 1, 0, 16384, 10, 1 ; high resolution sine wave for ORGAN oscili
giperc ftgen 2, 0, 2048,   5, 1, 2047, .00001 ; exponential table for Perc amplitude
gidist ftgen 3, 0, 257,    9, .5, 1, 270, 1.5, .33, 90, 2.5, .2, 270, 3.5, .143, 90, 4.5, .111, 270 ; for distortion unit
gitri  ftgen 0, 0, 1024,  -7, 0,512,1,512,0	; unipolar triangle wave

opcode	DopplerSpin,aa,akkkkki
	asig,kfreq,kAmpDepth,kAmpPhase,kPanDepth,kDopDep,ishape	xin
	
	isine		ftgen	0,0,1024,10,1
	aAmp 		osciliktp kfreq, ishape, kAmpPhase		; AN LFO DEFINES A VARIABLE USED TO MODULATE AMPLITUDE (NOTE: VARIABLE PHASE). THIS MODELS THE LOCATION WITHIN THE CIRCLE FROM WHICH WE ARE LISTENING. NO AMPLITUDE MODULATION REPRESENT REPRESENTS OUR LISTENING POSITION BEING EXACTLY CENTRAL, MAXIMUM MODULATION REPRESENTS US BEING NEAR TO THE EDGE OF A LARGE CIRCLE. THE CONTROL OVER PHASE OF THIS LFO REPRESENTS WHICH EDGE WE ARE CLOSER TO.
	aAmp		=	(aAmp * 0.5 * kAmpDepth) + 0.5		; RESCALE AND OFFSET AMPLITUDE MODULATION LFO
	
	aPan		oscili	(kPanDepth * 0.5), kfreq, ishape, 0.75	; AN LFO DEFINES A VARIABLE FOR PANNING CONTROL - I.E. WHETHER SOUND IS CURRENTLY TO OUT LEFT OR TO OUT RIGHT. NOTE THAT PHASE IS 0.75 AND THEREFORE 0.75 RADIANS (OR 270 DEGREES OUT OF PHASE) WITH THE DELAY MODULATION 
	aPan		=	aPan + 0.5				; OFFSET PANNING LFO

	iMaxDelay	=	4					; DEFINE A VARIABLE THAT WILL BE USE FOR 'MAXIMUM DELAY TIME' (BUFFER LENGTH)
	aDelTim		oscili	kDopDep, kfreq, ishape, 0		; AN LFO DEFINES A VARIABLE FOR DELAY TIME (NOTE PHASE AT ZERO)
	aDelTim		=	aDelTim + kDopDep			; DELAY TIME  VARIABLE 'aDelay' IS OFFSET TO STAY WITHIN THE POSITIVE DOMAIN	
		
	;vdelayxw IS USED FOR THE DELAY READ/WRITE AS IT MODULATES THE WRITE POINTER RATHER THAN THE READ POINTER.
	;THIS IS MORE APPROPRIATE IN THIS EXAMPLE AS THE SOURCE IS MOVING BUT THE POINT OF LISTENING IS STATIONARY
	aDelTap		vdelay	asig*aAmp, aDelTim, iMaxDelay;, 16
	
	aL, aR	pan2 	aDelTap, aPan, 1	;APPLY PANNING TO SIGNAL OUTPUT FROM DELAY USING pan2 OPCODE. CREATE A NEW 

		xout	aL,aR
	
endop

; all the MIDI note play ONLY the instrument 2 and also...
massign 0, 2
; the MIDI Program Change is ONLY for instr 2
pgmassign 0, 2

; this instrument remain always active: in this mode, it's always possible to view/hidden the Leslie Settings window
; and the Perc Decay knob, (not i-time only...)
instr 1
	; receiving GUI values
	ktrig  chnget "setup_Button"
	ktrig2 chnget "percenv"
	; when the "OnSet" GUI button is activated...
	if (ktrig == 1)  then
		chnset "visible(0)", "tubknob" ; hidden the "Tube" knob,
		chnset "visible(0)", "tublab"  ; hidden the "Tube" label,
		chnset "visible(0)", "masknob" ; hidden the "Master" knob,
		chnset "visible(0)", "maslab"  ; hidden the "Master" label,
		chnset "visible(1)", "setupPlant" ; but show the plant for setting the Leslie
	else ; otherwise
		chnset "visible(1)", "tubknob" ; show the "Tube" knob,
		chnset "visible(1)", "tublab"  ; show the "Tube" label,
		chnset "visible(1)", "masknob" ; show the "Master" knob,
		chnset "visible(1)", "maslab"  ; show the "Master" label,
		chnset "visible(0)", "setupPlant" ; but hidden the plant for setting the Leslie
	endif
	; when the "Decay/Note" button is activated...
	if (ktrig2 == 1) then
		chnset "visible(0)", "knobdec" ; hidden the "Perc Decay" knob
	else ; otherwise
		chnset "visible(1)", "knobdec" ; show the "Perc Decay" knob
	endif
endin

instr 2 ; Organ Instrument MONO
	; receiving GUI values
	kmaster    chnget "master"
	ka1        chnget "a1"
	ka2        chnget "a2"
	ka3        chnget "a3"
	ka4        chnget "a4"
	ka5        chnget "a5"
	ka6        chnget "a6"
	ka7        chnget "a7"
	ka8        chnget "a8"
	ka9        chnget "a9"
	kperclvl   chnget "perclvl"
	iperctne   chnget "perctne"
	ipercdec   chnget "percdec"
	kmaster    chnget "master"
	kcliclvl   chnget "cliclvl"
	ibutton1   chnget "button1"
	ipercenv   chnget "percenv"
	ktube      chnget "tube"
	ilesonoff  chnget "lesonoff"
	; MIDI note number at MIDI port input
	imidi notnum 
	; Pitch-Bender in MIDI note number values (with 1+ and 1- octaves range)
	kpb pchbend 0, 12
	; Click's Envelope
	aclick madsr .0000000000001, .02, 0, .1, 0, 1
	; reading velocity value for "animate" the click signal
	ivelo veloc 0, 10
	; rescaling click noise to velocity amount
	aclick = aclick * ivelo
	; Click at note On
	aclick noise aclick, 0.999
	; Control amplitude for Click signal
	anoion = aclick * kcliclvl
	; What is the Perc Tune?
	if     (iperctne == 0) then
		iperc = imidi + 24
	elseif (iperctne == 1) then
		iperc = imidi + 28
	elseif (iperctne == 2) then
		iperc = imidi + 31
	elseif (iperctne == 3) then
		iperc = imidi + 36
	endif
	; convert to cps the summing of midi values for oscillators and Perc Tune separately
	knote cpsmidinn imidi + kpb
	iperc cpsmidinn iperc
	; what is the profile chosen for the envelope amplitude?
	if (ipercenv == 0) then
		; Amplitude with Gen for Perc Oscili
		aline  linseg 0, ipercdec, 2047 ; this line of code generate one segment from 0 to 2047 in the idec time: this is the index for reading the table
		aenv2  tablei aline, 2 ; tablei reads the ftgen table number 2 using the aline index
	else
		; Amplitude with linseg for Perc Oscili
		aenv2  expsegr  1,ipercdec,0.00001,0.01,0.00001
	endif
	; Audio Perc Generation
	aperc oscili aenv2, iperc, 1
	; control Perc amplitude
	aperc = aperc * kperclvl
	; calculate the wright different cps for each oscillator
	knote1 =  knote * .5  ; 16'
	knote2 =  knote * 1.5 ; 5 1/3
	knote3 =  knote       ; 8'
	knote4 =  knote * 2   ; 4'
	knote5 =  knote * 3   ; 2 2/3
	knote6 =  knote * 4   ; 2'
	knote7 =  knote * 5   ; 1 3/5
	knote8 =  knote * 6   ; 1 1/3
	knote9 =  knote * 8   ; 1
	; Amplitude envelope generation (NOTE: line at a rate because at k rate noise are present in the final audio mix)
	aenv1 madsr .0000000000001, .1, 1, .1, 0, 1
	; Audio generation
	a1 oscili aenv1 * ka1, knote1, 1
	a2 oscili aenv1 * ka2, knote2, 1
	a3 oscili aenv1 * ka3, knote3, 1
	a4 oscili aenv1 * ka4, knote4, 1
	a5 oscili aenv1 * ka5, knote5, 1
	a6 oscili aenv1 * ka6, knote6, 1
	a7 oscili aenv1 * ka7, knote7, 1
	a8 oscili aenv1 * ka8, knote8, 1
	a9 oscili aenv1 * ka9, knote9, 1
	; mixing all audio signals from oscili and redefine the global max amplitude
	asum sum a1, a2, a3, a4, a5, a6, a7, a8, a9
	; control the wave amplitude
	awave = asum * .1
    ; generating a line for smoothing values
	kporttime	linseg	0,0.001,0.05
    ; Smooth k values
	ktube portk ktube,    kporttime
    ; distortion unit
	adist distort awave, ktube, 3
	; smoothing master knob values
	amaster	interp	kmaster
	; mixing all the non distorted signals
	asignal = awave+aperc+anoion
	; Wet/Dry distorted signal
	asignal ntrpol asignal, adist, ktube
	; leslie on/off
	if (ilesonoff == 0) then
		; mix only into send bus named 'leslie', not to soundcard out
		chnmix		asignal * amaster,"sendL"
		chnmix		asignal * amaster,"sendR"
		; clear audio send channel (organ+leslie)
		chnclear	"leslie"
	else
		chnmix		asignal * amaster,"leslie"
		; clear audio send channel (organ+leslie)
		chnclear	"sendL"
		chnclear	"sendR"	
	endif
	; auto control to turn-off the instrument (because if release the played note after the "aenv2" time, click are generated...)
	xtratim ipercdec
endin


;Code taken from the Leslie Speaker example made by Iain McCurdy 
instr 901	; a Leslie speaker effect
	 kSpeed	chnget	"Fast"									; read 'Slow' button widget
	 														; 0=slow 1=fast
	 aMix	chnget	"leslie"								; read in organ sound from instr 1
	 ; clear audio send channel
 	 chnclear	"leslie"
	 
	 kCF_High	chnget	"CF_High"							;crossover cutoff frequencies
	 kCF_Low	chnget	"CF_Low"
	 
	 kHF_Slow	=	chnget:k("HF_Slow")/60					; tweeter chorale (slow) speed
	 kHF_Fast	=	chnget:k("HF_Fast")/60					; tweeter tremolo (fast) speed
	
	 kLF_Slow	=	chnget:k("LF_Slow")/60					; tweeter chorale (slow) speed
	 kLF_Fast	=	chnget:k("LF_Fast")/60					; woofer tremolo (fast) speed
	 
	 kHF_Damp	chnget	"HF_Damp"							; tweeter speed change time
	 kLF_Damp	chnget	"LF_Damp"							; woofer speed change time
	 
	 kHF_Trem	chnget	"HF_Trem"							; tremolo modulation depth
	 kLF_Trem	chnget	"LF_Trem"
	 
	 kHF_Dop	chnget	"HF_Dop"							; doppler modulation depth
	 kLF_Dop	chnget	"LF_Dop"
	 
	 kHF_Pan	chnget	"HF_Pan"							; panning modulation depth
	 kLF_Pan	chnget	"HF_Pan"
	 
	 kHF_Amp	chnget	"HF_Amp"							; amplitude modulation depth
	 kLF_Amp	chnget	"LF_Amp"
	
	 aLF		butlp	aMix,kCF_Low						; woofer audio signal
	 aHF		buthp	aMix,kCF_High						; tweeter audio signal
	
	 if kSpeed==0 then										; if speed is slow
	  kLF_Speed	=	kLF_Slow								; set woofer speed to slow speed as defined in the set-up pop-up
	  kHF_Speed	=	kHF_Slow								; set tweeter speed to slow speed as defined in the set-up pop-up
	 else
	  kLF_Speed	=	kLF_Fast								; set woofer speed to slow speed as defined in the set-up pop-up
	  kHF_Speed	=	kHF_Fast								; set tweeter speed to slow speed as defined in the set-up pop-up
	 endif
	 
	 kportramp	linseg	0,0.01,1							; portamento time ramps up quickly from zero
	 kLF_Speed	portk	kLF_Speed,kLF_Damp					; damp speed change from 
	 kHF_Speed	portk	kHF_Speed,kHF_Damp
	
	 aHF_L,aHF_R	DopplerSpin	aHF,kHF_Speed,kHF_Amp,0.5,kHF_Pan,kHF_Dop,gisine	; call UDO
	 aLF_L,aLF_R	DopplerSpin	aLF,kLF_Speed,kLF_Amp,0.5,kLF_Pan,kLF_Dop,gisine
	 
			outs	aHF_L,aHF_R
	 		outs	aLF_L,aLF_R
			
	; send the audio using others 2 send busses
	chnmix		aHF_L,"sendL"
	chnmix		aHF_R,"sendR"    
endin

; Reverb Instrument STEREO
instr 902
	; receiving GUI values
	kroom chnget "room"
	kdmph chnget "dmph"
	kmix  chnget "reverb"
	; receiving audio send busses
	asigL chnget "sendL"
	asigR chnget "sendR"
	; clear audio send busses
	chnclear	"sendL"
	chnclear	"sendR"
	; generating a line for smoothing values
	kporttime	linseg	0,0.001,0.05
	; Smooth k values
	kroom portk kroom,    kporttime
	kdmph portk kdmph,    kporttime
	; Reverb
	arL, arR  freeverb asigL, asigR, kroom, kdmph, sr, 0

	; Wet\Dry reverb
	arL ntrpol asigL, arL, kmix
	arR ntrpol asigR, arR, kmix
	; Audio out with GUI gain control
	outs arL, arR
endin

; This Instrument is Suggested by Guillermo Senna (gsenna) on Cabbage forum (Thanks!)
instr   130
	; Read the MIDI bus and...
    kstatus, kchan, kdata1, kdata2 midiin 
    ; if kstatus is equal of 192 (192 is the value of MIDI Program Change)
    if (kstatus == 192) then 
    	; Increase kdata and send his value at the combobox that control the presets
        chnset kdata1+1, "combobox" 
    endif 
endin

</CsInstruments>
<CsScore>
i 1   0 [3600*24] ; GUI Control Instrument
i 130 0 [3600*24] ; MIDI Program Change control Instrument
i 901 0 [3600*24] ; Leslie Instrument
i 902 0 [3600*24] ; Reverb Instrument
</CsScore>
</CsoundSynthesizer>